// Telegrammer - Telegram Bot Swift SDK.
// This file is autogenerated by API/generate_wrappers.rb script.

/// Represents a link to a video file stored on the Telegram servers. By default, this video file will be sent by the user with an optional caption. Alternatively, you can use input_message_content to send a message with the specified content instead of the video.
///
/// [- SeeAlso: ]<https://core.telegram.org/bots/api#inlinequeryresultcachedvideo>

public final class InlineQueryResultCachedVideo: Codable {
    
    enum CodingKeys: String, CodingKey {
        case type = "type"
        case id = "id"
        case videoFileId = "video_file_id"
        case title = "title"
        case description = "description"
        case caption = "caption"
        case parseMode = "parse_mode"
        case replyMarkup = "reply_markup"
        case inputMessageContent = "input_message_content"
    }

    public var type: String
    public var id: String
    public var videoFileId: String
    public var title: String
    public var description: String?
    public var caption: String?
    public var parseMode: String?
    public var replyMarkup: InlineKeyboardMarkup?
    public var inputMessageContent: InputMessageContent?

    public init (type: String, id: String, videoFileId: String, title: String, description: String? = nil, caption: String? = nil, parseMode: String? = nil, replyMarkup: InlineKeyboardMarkup? = nil, inputMessageContent: InputMessageContent? = nil) {
        self.type = type
        self.id = id
        self.videoFileId = videoFileId
        self.title = title
        self.description = description
        self.caption = caption
        self.parseMode = parseMode
        self.replyMarkup = replyMarkup
        self.inputMessageContent = inputMessageContent
    }

}

